hdu 1427 速算24点 dfs暴力搜索

速算24点

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Problem Description

速算24点相信绝大多数人都玩过。就是随机给你四张牌,包括A(1),2,3,4,5,6,7,8,9,10,J(11),Q(12),K(13)。要求只用‘+‘,‘-‘,‘*‘,‘/‘运算符以及括号改变运算顺序,使得最终运算结果为24(每个数必须且仅能用一次)。游戏很简单,但遇到无解的情况往往让人很郁闷。你的任务就是针对每一组随机产生的四张牌,判断是否有解。我们另外规定,整个计算过程中都不能出现小数。

Input

每组输入数据占一行,给定四张牌。

Output

每一组输入数据对应一行输出。如果有解则输出"Yes",无解则输出"No"。

Sample Input

A 2 3 6
3 3 8 8

Sample Output

Yes
No

Author

LL

思路:暴力搜索,利用next_permutation全排列

#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define mod 1000000007
#define inf 999999999
#define esp 0.00000000001
//#pragma comment(linker, "/STACK:102400000,102400000")
int scan()
{
    int res = 0 , ch ;
    while( !( ( ch = getchar() ) >= ‘0‘ && ch <= ‘9‘ ) )
    {
        if( ch == EOF ) return 1 << 30 ;
    }
    res = ch - ‘0‘ ;
    while( ( ch = getchar() ) >= ‘0‘ && ch <= ‘9‘ )
        res = res * 10 + ( ch - ‘0‘ ) ;
    return res ;
}
int a[5];
int ans;
int getnum(string a)
{
    if(a[0]==‘1‘)
    return 10;
    if(a[0]>=‘2‘&&a[0]<=‘9‘)
    return a[0]-‘0‘;
    if(a[0]==‘A‘)
    return 1;
    if(a[0]==‘J‘)
        return 11;
    if(a[0]==‘K‘)
        return 13;
    if(a[0]==‘Q‘)
    return 12;
}
void dfs(int num,int gg,int step)
{
    if(step==4)
    {
        if(num==24)
        ans=1;
        return;
    }
    //不加括号
    dfs(num+gg,a[step+1],step+1);
    dfs(num-gg,a[step+1],step+1);
    dfs(num*gg,a[step+1],step+1);
    if(gg!=0&&num%gg==0)
    dfs(num/gg,a[step+1],step+1);
    //加括号
    if(step!=3)
    {
        dfs(num,gg+a[step+1],step+1);
        dfs(num,gg*a[step+1],step+1);
        dfs(num,gg-a[step+1],step+1);
        if(a[step+1]!=0&&gg%a[step+1]==0)
        dfs(num,gg/a[step+1],step+1);
    }
}
string ch[10];
int main()
{
    int x,y,z,i,t;
    while(cin>>ch[0]>>ch[1]>>ch[2]>>ch[3])
    {
        ans=0;
        for(i=0;i<4;i++)
        a[i]=getnum(ch[i]);
        sort(a,a+4);
        do
        {
            dfs(a[0],a[1],1);
        }
        while(next_permutation(a,a+4));
        if(ans)
        printf("Yes\n");
        else
        printf("No\n");
    }
    return 0;
}
时间: 2024-10-19 09:33:24

hdu 1427 速算24点 dfs暴力搜索的相关文章

[HDU 1427]速算24点(DFS暴搜)

题目连接:  http://acm.hdu.edu.cn/showproblem.php?pid=1427 思路:简单的DFS,dfs(sum,next,p)表示当前已经算出的值是sum,括号中算出的值是next,当前使用的卡片下标为p,实际上是把括号外和括号内的两部分值分成sum和next来处理了. 直觉告诉我们4个数只需要一层括号参与运算就够了,不会也不必用多重括号改变运算顺序,因此上面的dfs思路是正确的. 那么对于下一张卡片,有两种处理方式: 1.把next算入sum中,下一张卡片成

HDU 1427 速算24点【数值型DFS】

速算24点 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 2562    Accepted Submission(s): 606 Problem Description 速算24点相信绝大多数人都玩过.就是随机给你四张牌,包括A(1),2,3,4,5,6,7,8,9,10,J(11),Q(12),K(13).要求只用'+','-','*

HDU 1427 速算24点

全排列,枚举运算符,枚举优先级. #include<cstdio> #include<cstring> #include<cmath> #include<algorithm> using namespace std; const int INF=0x7FFFFFFF; char s[5]; int a[5],b[5],f[5],op[5],ans; int get() { if(s[0]=='A') return 1; if(s[0]=='J') retur

hdu 1427 速算24点(next_permutation 搜索)

题意:给出四张扑克牌 问能否算出24 思路:http://blog.csdn.net/xingyeyongheng/article/details/11137631 其实这题只有两种运算顺序 1([email protected])@[email protected] 2 ([email protected])@([email protected]) 所以只需要把数字和运算符全排列遍历一边就可以判断出结果 #include<cstdio> #include<cstring> #in

Hdoj 1427 速算24点 【DFS】

速算24点 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3574    Accepted Submission(s): 869 Problem Description 速算24点相信绝大多数人都玩过.就是随机给你四张牌,包括A(1),2,3,4,5,6,7,8,9,10,J(11),Q(12),K(13).要求只用'+','-','

HDU 1247 速算24点_BFS

1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #define CL(x, y) memset(x, y, sizeof(x)) 5 using namespace std; 6 const int INF = 1 << 30; 7 int num[4], res[4], used[4]; 8 int flag; 9 int getNum(char ch); 10 int ca

TOJ 1344 速算24点(全排列+dfs)

描述 速算24点相信绝大多数人都玩过.就是随机给你四张牌,包括A(1),2,3,4,5,6,7,8,9,10,J(11),Q(12),K(13).要求只用'+','-','*','/'运算符以及括号改变运算顺序,使得最终运算结果为24(每个数必须且仅能用一次).游戏很简单,但遇到无解的情况往往让人很郁闷.你的任务就是针对每一组随机产生的四张牌,判断是否有解.我们另外规定,整个计算过程中都不能出现小数. 输入 每组输入数据占一行,给定四张牌. 输出 每一组输入数据对应一行输出.如果有解则输出"Ye

hdu1427 速算24点

</pre><pre> //#pragma comment(linker, "/STACK:102400000,102400000") //HEAD #include <cstdio> #include <cstring> #include <vector> #include <iostream> #include <algorithm> #include <queue> #include

Problem A: 速算24点

Description 速算24点相信绝大多数人都玩过.就是随机给你四张牌,包括 A(1),2,3,4,5,6,7,8,9,10,J(11),Q(12),K(13).要求只用'+','-','*','/'运算符以及括号改变运算 顺序,使得最终运算结果为24(每张牌必须且仅能用一次).游戏很简单,但遇到无解的情况往往让人很郁闷.你的任务就是针对每一组随机产生的四张牌,判断 是否有解.我们另外规定,整个计算过程中都不能出现小数. Input 输入数据占一行,给定四张牌. Output 如果有解则输出